import { Component, Input, ViewEncapsulation, NgModule, ElementRef, Renderer2, ViewChild, EventEmitter, Output } from '@angular/core';
import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { CommonModule } from '@angular/common';
import { OverlayOrigin } from '@angular/cdk/overlay';
import { NtOverlayComponent, NtOverlayModule } from '@ng-tangram/components/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtAntIconComponent {
}
NtAntIconComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-ant-icon',
                template: '<i class="anticon icon-{{type}}"></i>',
                encapsulation: ViewEncapsulation.None
            },] },
];
/** @nocollapse */
NtAntIconComponent.ctorParameters = () => [];
NtAntIconComponent.propDecorators = {
    "type": [{ type: Input },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtIconModule {
    /**
     * @return {?}
     */
    static forRoot() {
        return { ngModule: NtIconModule };
    }
}
NtIconModule.decorators = [
    { type: NgModule, args: [{
                exports: [NtAntIconComponent],
                declarations: [NtAntIconComponent],
                entryComponents: [NtAntIconComponent]
            },] },
];
/** @nocollapse */
NtIconModule.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtButtonGroupComponent {
    constructor() {
        this._expanded = false;
        this.color = '';
        this.size = '';
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set expanded(value) { this._expanded = coerceBooleanProperty(value); }
    /**
     * @return {?}
     */
    get expanded() { return this._expanded; }
}
NtButtonGroupComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-button-group, [nt-button-group]',
                template: `<ng-content></ng-content>`,
                encapsulation: ViewEncapsulation.None,
                host: {
                    '[class]': '["button-group", color, size].join(" ")',
                    '[class.expanded]': 'expanded'
                }
            },] },
];
/** @nocollapse */
NtButtonGroupComponent.ctorParameters = () => [];
NtButtonGroupComponent.propDecorators = {
    "color": [{ type: Input },],
    "size": [{ type: Input },],
    "expanded": [{ type: Input },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtButtonComponent {
    constructor() {
        this._style = '';
        this._expanded = false;
        this.color = '';
        this.size = '';
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set _default(value) {
        if (value && this._validStyle(value)) {
            this._style = value;
        }
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set style(value) { this._style = value; }
    /**
     * @return {?}
     */
    get style() { return this._style; }
    /**
     * @param {?} value
     * @return {?}
     */
    set expanded(value) { this._expanded = coerceBooleanProperty(value); }
    /**
     * @return {?}
     */
    get expanded() { return this._expanded; }
    /**
     * @param {?} value
     * @return {?}
     */
    _validStyle(value) {
        return ['hollow', 'clear'].indexOf(value) > -1;
    }
}
NtButtonComponent.decorators = [
    { type: Component, args: [{
                selector: '[nt-button]',
                template: `<ng-content></ng-content>`,
                encapsulation: ViewEncapsulation.None,
                host: {
                    '[class]': '["button", color, style, size].join(" ")',
                    '[class.expanded]': 'expanded'
                }
            },] },
];
/** @nocollapse */
NtButtonComponent.ctorParameters = () => [];
NtButtonComponent.propDecorators = {
    "color": [{ type: Input },],
    "size": [{ type: Input },],
    "_default": [{ type: Input, args: ['nt-button',] },],
    "style": [{ type: Input },],
    "expanded": [{ type: Input },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtButtonModule {
}
NtButtonModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                exports: [NtButtonComponent, NtButtonGroupComponent],
                declarations: [NtButtonComponent, NtButtonGroupComponent],
            },] },
];
/** @nocollapse */
NtButtonModule.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtDropdownPaneComponent {
    constructor() {
        this.size = 'small';
    }
}
NtDropdownPaneComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-dropdown-pane, [nt-dropdown-pane]',
                template: "<div class=\"dropdown-pane {{size}}\"> <ng-content></ng-content> </div> ",
                encapsulation: ViewEncapsulation.None
            },] },
];
/** @nocollapse */
NtDropdownPaneComponent.ctorParameters = () => [];
NtDropdownPaneComponent.propDecorators = {
    "size": [{ type: Input },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtDropdownComponent {
    /**
     * @param {?} _renderer
     * @param {?} _elementRef
     */
    constructor(_renderer, _elementRef) {
        this._renderer = _renderer;
        this._elementRef = _elementRef;
        this.position = 'bottomLeft';
        this.trigger = 'hover';
        this.origin = new OverlayOrigin(_elementRef);
    }
}
NtDropdownComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-dropdown, [nt-dropdown]',
                template: "<ng-content></ng-content> <nt-overlay [origin]=\"origin\" [position]=\"position\" [trigger]=\"trigger\"> <ng-content select=\"nt-dropdown-pane\"></ng-content> </nt-overlay> ",
                encapsulation: ViewEncapsulation.None,
                host: {
                    '(click)': 'overlay.click()',
                    '(mouseenter)': 'overlay.onMouseEnter()',
                    '(mouseleave)': 'overlay.onMouseLeave()'
                }
            },] },
];
/** @nocollapse */
NtDropdownComponent.ctorParameters = () => [
    { type: Renderer2, },
    { type: ElementRef, },
];
NtDropdownComponent.propDecorators = {
    "position": [{ type: Input },],
    "trigger": [{ type: Input },],
    "overlay": [{ type: ViewChild, args: [NtOverlayComponent,] },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtDropdownModule {
}
NtDropdownModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, NtOverlayModule],
                entryComponents: [NtDropdownComponent],
                exports: [NtDropdownComponent, NtDropdownPaneComponent],
                declarations: [NtDropdownComponent, NtDropdownPaneComponent]
            },] },
];
/** @nocollapse */
NtDropdownModule.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtPopConfirmComponent {
    /**
     * @param {?} _renderer
     * @param {?} _elementRef
     */
    constructor(_renderer, _elementRef) {
        this._renderer = _renderer;
        this._elementRef = _elementRef;
        this.title = '';
        this.position = 'top';
        this.confirm = new EventEmitter();
        this.cancel = new EventEmitter();
        this.origin = new OverlayOrigin(_elementRef);
    }
    /**
     * @param {?} isConfirm
     * @return {?}
     */
    _closeOverlay(isConfirm) {
        (isConfirm ? this.confirm : this.cancel).emit();
        this.overlay.hide();
    }
}
NtPopConfirmComponent.decorators = [
    { type: Component, args: [{
                selector: '[nt-popconfirm]',
                template: "<ng-content></ng-content> <nt-overlay [origin]=\"origin\" [position]=\"position\" trigger=\"click\" arrow> <nt-dropdown-pane> <p class=\"popconfirm\"><nt-ant-icon class=\"popconfirm-icon\" type=\"infocirlce\"></nt-ant-icon> {{ title }}</p> <div class=\"popconfirm-action\"> <button nt-button color=\"secondary\" size=\"tiny\" (click)=\"_closeOverlay(false)\">取消</button> <button nt-button size=\"tiny\" (click)=\"_closeOverlay(true)\">确认</button> </div> </nt-dropdown-pane> </nt-overlay> ",
                encapsulation: ViewEncapsulation.None,
                host: {
                    '(click)': 'overlay.click()'
                }
            },] },
];
/** @nocollapse */
NtPopConfirmComponent.ctorParameters = () => [
    { type: Renderer2, },
    { type: ElementRef, },
];
NtPopConfirmComponent.propDecorators = {
    "title": [{ type: Input, args: ['nt-popconfirm',] },],
    "position": [{ type: Input },],
    "confirm": [{ type: Output },],
    "cancel": [{ type: Output },],
    "overlay": [{ type: ViewChild, args: [NtOverlayComponent,] },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtPopConfirmModule {
}
NtPopConfirmModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, NtOverlayModule, NtIconModule, NtButtonModule, NtDropdownModule],
                exports: [NtPopConfirmComponent],
                declarations: [NtPopConfirmComponent]
            },] },
];
/** @nocollapse */
NtPopConfirmModule.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

export { NtPopConfirmModule, NtPopConfirmComponent, NtButtonModule as ɵb, NtDropdownModule as ɵc, NtIconModule as ɵa };
//# sourceMappingURL=popconfirm.js.map
