import { Component, Input, ViewEncapsulation, NgModule, ElementRef, Renderer2, ViewChild, EventEmitter, Output } from '@angular/core';
import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { CommonModule } from '@angular/common';
import { OverlayOrigin } from '@angular/cdk/overlay';
import { NtOverlayComponent, NtOverlayModule } from '@ng-tangram/components/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtAntIconComponent = /** @class */ (function () {
    function NtAntIconComponent() {
    }
    NtAntIconComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-ant-icon',
                    template: '<i class="anticon icon-{{type}}"></i>',
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    NtAntIconComponent.ctorParameters = function () { return []; };
    NtAntIconComponent.propDecorators = {
        "type": [{ type: Input },],
    };
    return NtAntIconComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtIconModule = /** @class */ (function () {
    function NtIconModule() {
    }
    /**
     * @return {?}
     */
    NtIconModule.forRoot = /**
     * @return {?}
     */
    function () {
        return { ngModule: NtIconModule };
    };
    NtIconModule.decorators = [
        { type: NgModule, args: [{
                    exports: [NtAntIconComponent],
                    declarations: [NtAntIconComponent],
                    entryComponents: [NtAntIconComponent]
                },] },
    ];
    /** @nocollapse */
    NtIconModule.ctorParameters = function () { return []; };
    return NtIconModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtButtonGroupComponent = /** @class */ (function () {
    function NtButtonGroupComponent() {
        this._expanded = false;
        this.color = '';
        this.size = '';
    }
    Object.defineProperty(NtButtonGroupComponent.prototype, "expanded", {
        get: /**
         * @return {?}
         */
        function () { return this._expanded; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._expanded = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    NtButtonGroupComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-button-group, [nt-button-group]',
                    template: "<ng-content></ng-content>",
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        '[class]': '["button-group", color, size].join(" ")',
                        '[class.expanded]': 'expanded'
                    }
                },] },
    ];
    /** @nocollapse */
    NtButtonGroupComponent.ctorParameters = function () { return []; };
    NtButtonGroupComponent.propDecorators = {
        "color": [{ type: Input },],
        "size": [{ type: Input },],
        "expanded": [{ type: Input },],
    };
    return NtButtonGroupComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtButtonComponent = /** @class */ (function () {
    function NtButtonComponent() {
        this._style = '';
        this._expanded = false;
        this.color = '';
        this.size = '';
    }
    Object.defineProperty(NtButtonComponent.prototype, "_default", {
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value && this._validStyle(value)) {
                this._style = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtButtonComponent.prototype, "style", {
        get: /**
         * @return {?}
         */
        function () { return this._style; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._style = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtButtonComponent.prototype, "expanded", {
        get: /**
         * @return {?}
         */
        function () { return this._expanded; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._expanded = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} value
     * @return {?}
     */
    NtButtonComponent.prototype._validStyle = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return ['hollow', 'clear'].indexOf(value) > -1;
    };
    NtButtonComponent.decorators = [
        { type: Component, args: [{
                    selector: '[nt-button]',
                    template: "<ng-content></ng-content>",
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        '[class]': '["button", color, style, size].join(" ")',
                        '[class.expanded]': 'expanded'
                    }
                },] },
    ];
    /** @nocollapse */
    NtButtonComponent.ctorParameters = function () { return []; };
    NtButtonComponent.propDecorators = {
        "color": [{ type: Input },],
        "size": [{ type: Input },],
        "_default": [{ type: Input, args: ['nt-button',] },],
        "style": [{ type: Input },],
        "expanded": [{ type: Input },],
    };
    return NtButtonComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtButtonModule = /** @class */ (function () {
    function NtButtonModule() {
    }
    NtButtonModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    exports: [NtButtonComponent, NtButtonGroupComponent],
                    declarations: [NtButtonComponent, NtButtonGroupComponent],
                },] },
    ];
    /** @nocollapse */
    NtButtonModule.ctorParameters = function () { return []; };
    return NtButtonModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtDropdownPaneComponent = /** @class */ (function () {
    function NtDropdownPaneComponent() {
        this.size = 'small';
    }
    NtDropdownPaneComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-dropdown-pane, [nt-dropdown-pane]',
                    template: "<div class=\"dropdown-pane {{size}}\"> <ng-content></ng-content> </div> ",
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    NtDropdownPaneComponent.ctorParameters = function () { return []; };
    NtDropdownPaneComponent.propDecorators = {
        "size": [{ type: Input },],
    };
    return NtDropdownPaneComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtDropdownComponent = /** @class */ (function () {
    function NtDropdownComponent(_renderer, _elementRef) {
        this._renderer = _renderer;
        this._elementRef = _elementRef;
        this.position = 'bottomLeft';
        this.trigger = 'hover';
        this.origin = new OverlayOrigin(_elementRef);
    }
    NtDropdownComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-dropdown, [nt-dropdown]',
                    template: "<ng-content></ng-content> <nt-overlay [origin]=\"origin\" [position]=\"position\" [trigger]=\"trigger\"> <ng-content select=\"nt-dropdown-pane\"></ng-content> </nt-overlay> ",
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        '(click)': 'overlay.click()',
                        '(mouseenter)': 'overlay.onMouseEnter()',
                        '(mouseleave)': 'overlay.onMouseLeave()'
                    }
                },] },
    ];
    /** @nocollapse */
    NtDropdownComponent.ctorParameters = function () { return [
        { type: Renderer2, },
        { type: ElementRef, },
    ]; };
    NtDropdownComponent.propDecorators = {
        "position": [{ type: Input },],
        "trigger": [{ type: Input },],
        "overlay": [{ type: ViewChild, args: [NtOverlayComponent,] },],
    };
    return NtDropdownComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtDropdownModule = /** @class */ (function () {
    function NtDropdownModule() {
    }
    NtDropdownModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, NtOverlayModule],
                    entryComponents: [NtDropdownComponent],
                    exports: [NtDropdownComponent, NtDropdownPaneComponent],
                    declarations: [NtDropdownComponent, NtDropdownPaneComponent]
                },] },
    ];
    /** @nocollapse */
    NtDropdownModule.ctorParameters = function () { return []; };
    return NtDropdownModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtPopConfirmComponent = /** @class */ (function () {
    function NtPopConfirmComponent(_renderer, _elementRef) {
        this._renderer = _renderer;
        this._elementRef = _elementRef;
        this.title = '';
        this.position = 'top';
        this.confirm = new EventEmitter();
        this.cancel = new EventEmitter();
        this.origin = new OverlayOrigin(_elementRef);
    }
    /**
     * @param {?} isConfirm
     * @return {?}
     */
    NtPopConfirmComponent.prototype._closeOverlay = /**
     * @param {?} isConfirm
     * @return {?}
     */
    function (isConfirm) {
        (isConfirm ? this.confirm : this.cancel).emit();
        this.overlay.hide();
    };
    NtPopConfirmComponent.decorators = [
        { type: Component, args: [{
                    selector: '[nt-popconfirm]',
                    template: "<ng-content></ng-content> <nt-overlay [origin]=\"origin\" [position]=\"position\" trigger=\"click\" arrow> <nt-dropdown-pane> <p class=\"popconfirm\"><nt-ant-icon class=\"popconfirm-icon\" type=\"infocirlce\"></nt-ant-icon> {{ title }}</p> <div class=\"popconfirm-action\"> <button nt-button color=\"secondary\" size=\"tiny\" (click)=\"_closeOverlay(false)\">取消</button> <button nt-button size=\"tiny\" (click)=\"_closeOverlay(true)\">确认</button> </div> </nt-dropdown-pane> </nt-overlay> ",
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        '(click)': 'overlay.click()'
                    }
                },] },
    ];
    /** @nocollapse */
    NtPopConfirmComponent.ctorParameters = function () { return [
        { type: Renderer2, },
        { type: ElementRef, },
    ]; };
    NtPopConfirmComponent.propDecorators = {
        "title": [{ type: Input, args: ['nt-popconfirm',] },],
        "position": [{ type: Input },],
        "confirm": [{ type: Output },],
        "cancel": [{ type: Output },],
        "overlay": [{ type: ViewChild, args: [NtOverlayComponent,] },],
    };
    return NtPopConfirmComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtPopConfirmModule = /** @class */ (function () {
    function NtPopConfirmModule() {
    }
    NtPopConfirmModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, NtOverlayModule, NtIconModule, NtButtonModule, NtDropdownModule],
                    exports: [NtPopConfirmComponent],
                    declarations: [NtPopConfirmComponent]
                },] },
    ];
    /** @nocollapse */
    NtPopConfirmModule.ctorParameters = function () { return []; };
    return NtPopConfirmModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

export { NtPopConfirmModule, NtPopConfirmComponent, NtButtonModule as ɵb, NtDropdownModule as ɵc, NtIconModule as ɵa };
//# sourceMappingURL=popconfirm.js.map
