import { Component, Input, ViewEncapsulation, ElementRef, Renderer2, ViewChild, NgModule } from '@angular/core';
import { OverlayOrigin } from '@angular/cdk/overlay';
import { NtOverlayComponent, NtOverlayModule } from '@ng-tangram/components/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtDropdownPaneComponent = /** @class */ (function () {
    function NtDropdownPaneComponent() {
        this.size = 'small';
    }
    NtDropdownPaneComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-dropdown-pane, [nt-dropdown-pane]',
                    template: "<div class=\"dropdown-pane {{size}}\"> <ng-content></ng-content> </div> ",
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    NtDropdownPaneComponent.ctorParameters = function () { return []; };
    NtDropdownPaneComponent.propDecorators = {
        "size": [{ type: Input },],
    };
    return NtDropdownPaneComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtDropdownComponent = /** @class */ (function () {
    function NtDropdownComponent(_renderer, _elementRef) {
        this._renderer = _renderer;
        this._elementRef = _elementRef;
        this.position = 'bottomLeft';
        this.trigger = 'hover';
        this.origin = new OverlayOrigin(_elementRef);
    }
    NtDropdownComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-dropdown, [nt-dropdown]',
                    template: "<ng-content></ng-content> <nt-overlay [origin]=\"origin\" [position]=\"position\" [trigger]=\"trigger\"> <ng-content select=\"nt-dropdown-pane\"></ng-content> </nt-overlay> ",
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        '(click)': 'overlay.click()',
                        '(mouseenter)': 'overlay.onMouseEnter()',
                        '(mouseleave)': 'overlay.onMouseLeave()'
                    }
                },] },
    ];
    /** @nocollapse */
    NtDropdownComponent.ctorParameters = function () { return [
        { type: Renderer2, },
        { type: ElementRef, },
    ]; };
    NtDropdownComponent.propDecorators = {
        "position": [{ type: Input },],
        "trigger": [{ type: Input },],
        "overlay": [{ type: ViewChild, args: [NtOverlayComponent,] },],
    };
    return NtDropdownComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtDropdownModule = /** @class */ (function () {
    function NtDropdownModule() {
    }
    NtDropdownModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, NtOverlayModule],
                    entryComponents: [NtDropdownComponent],
                    exports: [NtDropdownComponent, NtDropdownPaneComponent],
                    declarations: [NtDropdownComponent, NtDropdownPaneComponent]
                },] },
    ];
    /** @nocollapse */
    NtDropdownModule.ctorParameters = function () { return []; };
    return NtDropdownModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtPopoverPaneComponent = /** @class */ (function () {
    function NtPopoverPaneComponent() {
    }
    NtPopoverPaneComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-popover-pane, [nt-popover-pane]',
                    template: "\n    <ng-content></ng-content>\n  ",
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    NtPopoverPaneComponent.ctorParameters = function () { return []; };
    return NtPopoverPaneComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtPopoverComponent = /** @class */ (function () {
    function NtPopoverComponent(_renderer, _elementRef) {
        this._renderer = _renderer;
        this._elementRef = _elementRef;
        this.title = '';
        this.position = 'top';
        this.origin = new OverlayOrigin(_elementRef);
    }
    NtPopoverComponent.decorators = [
        { type: Component, args: [{
                    selector: '[nt-popover]',
                    template: "<ng-content></ng-content> <nt-overlay [origin]=\"origin\" [position]=\"position\" trigger=\"click\" arrow> <div class=\"dropdown-pane small popover\"> <div class=\"popover-title\" *ngIf=\"title\">{{title}}</div> <div class=\"popover-pane\"> <ng-content select=\"nt-popover-pane\"></ng-content> </div> </div> </nt-overlay> ",
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        '(click)': 'overlay.click()'
                    }
                },] },
    ];
    /** @nocollapse */
    NtPopoverComponent.ctorParameters = function () { return [
        { type: Renderer2, },
        { type: ElementRef, },
    ]; };
    NtPopoverComponent.propDecorators = {
        "title": [{ type: Input, args: ['nt-popover',] },],
        "position": [{ type: Input },],
        "overlay": [{ type: ViewChild, args: [NtOverlayComponent,] },],
    };
    return NtPopoverComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtPopoverModule = /** @class */ (function () {
    function NtPopoverModule() {
    }
    NtPopoverModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, NtOverlayModule, NtDropdownModule],
                    exports: [NtPopoverComponent, NtPopoverPaneComponent],
                    declarations: [NtPopoverComponent, NtPopoverPaneComponent]
                },] },
    ];
    /** @nocollapse */
    NtPopoverModule.ctorParameters = function () { return []; };
    return NtPopoverModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

export { NtPopoverModule, NtPopoverComponent, NtPopoverPaneComponent, NtDropdownModule as ɵa };
//# sourceMappingURL=popover.js.map
